-- FPU

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity FPU is

	port(SRC1,SRC2 : in std_logic_vector(31 downto 0);
	     FUNC      : in std_logic_vector(3 downto 0);
	     CLK       : in std_logic;
	     OUTPUT    : out std_logic_vector(31 downto 0));

end FPU;

architecture BEHAVIOR of FPU is
   component FMUL
       port(SRC1,SRC2 : in std_logic_vector(31 downto 0);
            OUTPUT : out std_logic_vector(31 downto 0));
   end component;
   --component FADD
   --    port(SRC1,SRC2 : in std_logic_vector(31 downto 0);
   --         OUTPUT : out std_logic_vector(31 downto 0));
   --end component;
   --component FSUB
   --    port(SRC1,SRC2 : in std_logic_vector(31 downto 0);
   --         OUTPUT : out std_logic_vector(31 downto 0));
   --end component;
   component FLESS
       port(SRC1,SRC2 : in std_logic_vector(31 downto 0);
            OUTPUT : out std_logic_vector(31 downto 0));
   end component;
   component ITOF
       port(SRC    : in std_logic_vector(31 downto 0);
            OUTPUT : out std_logic_vector(31 downto 0));
   end component;
   component FTOI
       port(SRC    : in std_logic_vector(31 downto 0);
            OUTPUT : out std_logic_vector(31 downto 0));
   end component;
   component FDIV
       port(SRC1,SRC2 : in std_logic_vector(31 downto 0);
            OUTPUT : out std_logic_vector(31 downto 0));
   end component;
   component SQRT
	port(SRC    : in std_logic_vector(31 downto 0);
	     OUTPUT : out std_logic_vector(31 downto 0));
   end component;
   component FINVSQRT_n
	port(SRC    : in std_logic_vector(31 downto 0);
	     OUTPUT : out std_logic_vector(31 downto 0));
   end component;
   component F_ADSB
       port(SRC1,SRC2 : in std_logic_vector(31 downto 0);
            FUNC      : in std_logic_vector(3 downto 0);
            OUTPUT : out std_logic_vector(31 downto 0));
   end component;
   component INV7
	port(SRC    : in std_logic_vector(31 downto 0);
	     OUTPUT : out std_logic_vector(31 downto 0));
   end component;
--   for all : FMUL use entity work.FMUL(STRUCTURE);
   signal OUT_FMUL  : std_logic_vector(31 downto 0);
   --signal OUT_FADD  : std_logic_vector(31 downto 0);
   --signal OUT_FSUB  : std_logic_vector(31 downto 0);
   signal OUT_ITOF  : std_logic_vector(31 downto 0);
   signal OUT_FTOI  : std_logic_vector(31 downto 0);
   signal OUT_FLESS : std_logic_vector(31 downto 0);
   signal OUT_FDIV  : std_logic_vector(31 downto 0);
   signal OUT_SQRT  : std_logic_vector(31 downto 0);
   signal OUT_FINVSQRT : std_logic_vector(31 downto 0);
   signal OUT_F_ADSB : std_logic_vector(31 downto 0);
   signal OUT_INV : std_logic_vector(31 downto 0);
begin -- BEHAVIOR
   --FMUL1 : FMUL port map (SRC1,SRC2,OUTPUT);
   FMUL1  : FMUL port map (SRC1,SRC2,OUT_FMUL);
   --FADD1  : FADD  port map (SRC1,SRC2,OUT_FADD);
   --FSUB1  : FSUB  port map (SRC1,SRC2,OUT_FSUB);
   FLESS1 : FLESS port map (SRC1,SRC2,OUT_FLESS);
   ITOF1  : ITOF  port map (SRC1,OUT_ITOF);
   FTOI1  : FTOI  port map (SRC1,OUT_FTOI);
   FDIV1  : FDIV  port map (SRC1,SRC2,OUT_FDIV);
   SQRT1  : SQRT  port map (SRC1,OUT_SQRT);
   FINVSQRT1 : FINVSQRT_n port map (SRC1,OUT_FINVSQRT);
   
   F_ADSB1 : F_ADSB port map (SRC1,SRC2,FUNC,OUT_F_ADSB);
   INV1   : INV7 port map (SRC1,OUT_INV);
   OUTPUT <= ----OUT_FADD     when FUNC = "0000" else
             ----OUT_FSUB     when FUNC = "0001" else
             OUT_F_ADSB   when FUNC = "0000" or FUNC = "0001" else
             OUT_FMUL     when FUNC = "0010" else
             OUT_FDIV     when FUNC = "0011" else
             OUT_SQRT     when FUNC = "0100" else
             OUT_FINVSQRT when FUNC = "0101" else
             OUT_FLESS    when FUNC = "0110" else
             OUT_FTOI     when FUNC = "1100" else
             OUT_ITOF     when FUNC = "1000" else
             OUT_INV      when FUNC = "1110" else
             "XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX";
             
             
             
   --FPU_P : process(SRC1,SRC2,FUNC,CLK)
   --begin -- FPU_P
   --    case FUNC is 
   --       when "0010" => OUTPUT <= OUT_FMUL;
   --       when "0000" => OUTPUT <= OUT_FADD;
   --       when "0001" => OUTPUT <= OUT_FSUB;
   --       when "0110" => OUTPUT <= OUT_FLESS;
   --       when "1000" => OUTPUT <= OUT_ITOF;
   --       when "1100" => OUTPUT <= OUT_FTOI;
   --       when "0011" => OUTPUT <= OUT_FDIV;
   --       when others => OUTPUT <= "XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX";
   --    end case;
   --end process;
      
end BEHAVIOR;


configuration FPU1 of FPU is
    for BEHAVIOR
    end for;
end FPU1;
